#include "TObjTArrC.h"

void hclient(Bool_t evol=kFALSE) 
{
   // Client program which creates and fills a histogram. Every 1000 fills
   // the histogram is send to the server which displays the histogram.
   //
   // To run this demo do the following:
   //   - Open three windows
   //   - Start ROOT in all three windows
   //   - Execute in the first window: .x hserv.C (or hserv2.C)
   //   - Execute in the second and third windows: .x hclient.C
   // If you want to run the hserv.C on a different host, just change
   // "localhost" in the TSocket ctor below to the desired hostname.
   //
   // The script argument "evol" can be used when using a modified version
   // of the script where the clients and server are on systems with
   // different versions of ROOT. When evol is set to kTRUE the socket will
   // support automatic schema evolution between the client and the server.
   //
   //Author: Fons Rademakers
   
   gBenchmark->Start("hclient");

   // Open connection to server
   TSocket *sock = new TSocket("localhost", 9090);

   // Wait till we get the start message
   char str[32];
   sock->Recv(str, 32);

   // server tells us who we are
   int idx = !strcmp(str, "go 0") ? 0 : 1;

   Float_t messlen  = 0;
   Float_t cmesslen = 0;
   if (idx == 1)
      sock->SetCompressionLevel(1);



	const Int_t length = 5;
	Char_t a[length];
	for (Int_t i=0; i<length; ++i) {
		a[i] = (Char_t) i;
		cout << i << ":" << (Int_t) a[i] << " ";
	}
	cout << endl;

	TObjTArrC * oa = new TObjTArrC(length, a);
//	TArrayC * tac = new TArrayC(length, a);
//	TObjTArrC * oa = new TObjTArrC(*tac);

	cout << "oa size: " << oa->GetSize() << endl;

	Char_t * na;
	na = oa->GetArray();
	for (Int_t i=0; i<oa->GetSize(); ++i) {
		cout << i << ":" << (Int_t) na[i] << " ";
	}
	cout << endl;

   TMessage::EnableSchemaEvolutionForAll(evol);
   TMessage mess(kMESS_OBJECT);
   //TMessage mess(kMESS_OBJECT | kMESS_ACK);

	mess.Reset();
	mess.WriteObject(oa);

	sock->Send(mess);
	messlen  += mess.Length();
	cmesslen += mess.CompLength();



   sock->Send("Finished");          // tell server we are finished

   if (cmesslen > 0)
      printf("Average compression ratio: %g\n", messlen/cmesslen);

//   gBenchmark->Show("hclient");

   // Close the socket
   sock->Close();
}
